﻿/*
 * Creado por SharpDevelop.
 * Usuario: Jorge
 * Fecha: 22/04/2013
 * Hora: 17:36
 * 
 * Para cambiar esta plantilla use Herramientas | Opciones | Codificación | Editar Encabezados Estándar
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using System.IO;
using System.Threading;

namespace EncrypDecryp
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		public MainForm()
		{
			InitializeComponent();
		}
		
		//public static string usuario = "";
		//public static string password = "";
		
		string   usuario            = "";                 // Clave original
        string   password           = "";                 // cualquier cadena
        string   saltValue          = "sALTpHR@SE";       // cualquier cadena
        string   hashAlgorithm      = "SHA1";             // puede ser "MD5"
        int      passwordIterations = 2;                  // cualquier número
        string   initVector         = "@1B2c3D4e5F6g7H8"; // puede ser de 16 bytes
        int      keySize            = 256;                // puede ser 192 or 128
        
        private void encryptar()
        {
        	usuario = textBox1.Text;
			password = textBox2.Text;
			
			DataGridViewCell dgc;
			
			//Recorremos el DataGridView con un bucle for
			for (int i = 0; i < dataGridView1.Rows.Count; i++)
				{
   					dgc = dataGridView1.Rows[i].Cells[0];
   					if (usuario == ((String)dgc.Value))
   					{
   						MessageBox.Show("Usuario ya existe.",
										"Atención",
										MessageBoxButtons.OK,
										MessageBoxIcon.Exclamation,
										MessageBoxDefaultButton.Button1);
   						
   						label3.Visible = false;
						label4.Visible = false;	
						textBox1.Text = "";
						textBox2.Text = "";
						textBox1.Focus();
   						break;
   					}
   					else
   					{
   						label3.Visible = true;
						label4.Visible = true;
						label4.Text = CifrarCadena.Encrypt(usuario, 
						                                   password, 
						                                   saltValue, 
						                                   hashAlgorithm, 
						                                   passwordIterations, 
						                                   initVector, 
						                                   keySize);
   					}
            } 
        }
        
        private void guardar()
        {
        	string[] currentColumn = new string[55];	
			currentColumn[0] = usuario;
			currentColumn[1] = label4.Text;
			
			// Se llevan al gridView
            dataGridView1.Rows.Add(currentColumn);
            label3.Visible = false;
			label4.Visible = false;	
			textBox1.Text = "";
			textBox2.Text = "";
			textBox1.Focus();
        }
        
        private void validar()
        {
        			panel2.Visible = true;
			if (textBox1.Text == "" || textBox2.Text == "")
				{
					MessageBox.Show("Debe completar los datos a validar...");
					textBox1.Focus();     				
				}
			
			usuario = textBox1.Text;
			password = textBox2.Text;
			
			string valid = 	CifrarCadena.Encrypt(usuario, 
			                                   password, 
			                                   saltValue, 
			                                   hashAlgorithm, 
			                                   passwordIterations, 
			                                   initVector, 
			                                   keySize);
			
			string desencr = "", gencr = "", vPar = "";
			DataGridViewCell dgc;
			
			//Recorremos el DataGridView con un bucle for
			for (int i = 0; i < dataGridView1.Rows.Count; i++)
				{
   					dgc = dataGridView1.Rows[i].Cells[0];
   					if (usuario == ((String)dgc.Value))
   					{
   						dgc = dataGridView1.Rows[i].Cells[1];
   						gencr = ((String)dgc.Value);
   						
   						desencr = CifrarCadena.Decrypt(gencr, 
   						                               password,
   						                               saltValue,
   						                               hashAlgorithm,
   						                               passwordIterations,
   						                               initVector,
   						                               keySize);
   						vPar = "Hay pareo";
   					}
				}
			
   					label3.Visible = false;
					label4.Visible = false;	
					textBox1.Text = "";
					textBox2.Text = "";
					textBox1.Focus();
			
					if (desencr == "Usuario o clave incorrecta...")
						vPar = "No hay pareo";
					
					if (desencr == "")
					{
						desencr = "Usuario NO existe";
							vPar = "No hay pareo";
					}
					
   					label9.Text = password;
   					label10.Text = valid;
   					label15.Text = usuario;
   					
   					label11.Text = desencr;
   					label12.Text = gencr;
   					label17.Text = vPar;
        }
        
		void EncriptarClick(object sender, EventArgs e)
		{
			encryptar();
		}
		
		void Button1Click(object sender, EventArgs e)
		{
			guardar();
		}
		
		void Button3Click(object sender, EventArgs e)
		{			
			validar();
		}
		
		void Button2Click(object sender, EventArgs e)
		{
			Close();
		}
		
		void EncriptarToolStripMenuItemClick(object sender, EventArgs e)
		{
			encryptar();
		}
		
		void GuardarToolStripMenuItemClick(object sender, EventArgs e)
		{
			guardar();
		}
		
		void ValidarToolStripMenuItemClick(object sender, EventArgs e)
		{
			validar();
		}
		
		void SalirToolStripMenuItemClick(object sender, EventArgs e)
		{
			Close();
		}
		
		void AyudaToolStripMenuItemClick(object sender, EventArgs e)
		{
			Cursor = Cursors.WaitCursor;
			Help.ShowHelp(this, Application.StartupPath + "\\Reijndael.chm");
			Cursor = Cursors.Default;			
		}
	}
}
